using FluentValidation;
using CMSMicroservice.Protobuf.Protos.ProductCategory;
namespace CMSMicroservice.Protobuf.Validator.ProductCategory;

public class GetAllProductCategoryByFilterRequestValidator : AbstractValidator<GetAllProductCategoryByFilterRequest>
{
    public GetAllProductCategoryByFilterRequestValidator()
    {
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetAllProductCategoryByFilterRequest>.CreateWithOptions((GetAllProductCategoryByFilterRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
